## FormFonts Exporter - Alpha version
##
### TIG tweaked 20110507
### reporting readded

require 'sketchup.rb'

class AF_FF

#exporter methods
def xpt_dwg()
  dwgpath = File.join(@outdir, @modelname+".dwg")
  @model.export(dwgpath, true)
end

def xpt_jpg(postp)
  if postp=="true" then
    jpgpath = File.join(@outdir, @modelname+"_thumb.jpg")
    myview = @model.active_view
    myview.invalidate
    thumb = myview.write_image(jpgpath, 400, 400, true, 7)
  else
    if postp=="IM" then
      Dir.chdir(@outdir)
      pngpath = @modelname+"_thumb.png"
      jpgpath = @modelname+"_thumb.jpg"
      myview = @model.active_view
      myview.invalidate
      thumb = myview.write_image(pngpath, 1600, 1200, true, 9)
        if RUBY_PLATFORM =~ /darwin/ then
          imcmd = "/opt/local/bin/convert "+pngpath+" -shave 200x0 -filter blackman -resize 400x400 -quality 100 "+jpgpath
        else
          imcmd = "\"C:\\Program Files\\ImageMagick-6.4.9-Q16\\convert.exe\" "+pngpath+" -shave 200x0 -filter blackman -resize 400x400 -quality 100 "+jpgpath
      end
      system(imcmd)
    else
      if postp == "IM DC" then
        Dir.chdir(@outdir)
        pngpath = @modelname+"_thumb.png"
        jpgpath = @modelname+"_thumb.jpg"
        myview = @model.active_view
        myview.invalidate
        thumb = myview.write_image(pngpath, 1600, 1200, true, 9)
        if RUBY_PLATFORM =~ /darwin/ then
          imcmd = "/opt/local/bin/convert "+pngpath+" -shave 200x0 -filter blackman -resize 400x400 -quality 100  -gravity southwest \""+@plugindir+"/dc_overlay.png\" -compose Over -composite "+jpgpath
        else
          imcmd = "\"C:\\Program Files\\ImageMagick-6.4.9-Q16\\convert.exe\" "+pngpath+" -shave 200x0 -filter blackman -resize 400x400 -quality 100  -gravity southwest \""+@plugindir+"\\dc_overlay.png\" -compose Over -composite "+jpgpath
        end
        system(imcmd)
      end
    end
  end
end

### these need a folder to hold 'bits'
def xpt_3ds()
  tdstmp = File.join(@outdir, "3dstmp")
  Dir.mkdir(tdstmp) if not File.exist?(tdstmp)
  tdspath = File.join(tdstmp, @modelname+".3ds")
  @model.export(tdspath, true)
  Dir.chdir(tdstmp)
  begin
    zipcmd = "zip -rqm "+@modelname+".3ds.zip *"
    system(zipcmd)
  rescue
    puts 'zip failed'
  end
  sleep(0.5)
  return if not File.exist?(tdspath+'.zip')
  @zipped=true
end

def xpt_fbx()
  fbxtmp = File.join(@outdir, "fbxtmp")
  Dir.mkdir(fbxtmp) if not File.exist?(fbxtmp)
  fbxpath = File.join(fbxtmp, @modelname+".fbx")
  @model.export(fbxpath, true)
  Dir.chdir(fbxtmp)
  begin
    zipcmd = "zip -rqm "+@modelname+".fbx.zip *"
    system(zipcmd)
  rescue
    puts 'zip failed'
  end
  sleep(0.5)
  return if not File.exist?(fbxpath+'.zip')
  @zipped=true
end

def xpt_dae()
  daetmp = File.join(@outdir, "daetmp")
  Dir.mkdir(daetmp) if not File.exist?(daetmp)
  daepath = File.join(daetmp, @modelname+".dae")
  @model.export(daepath, true)
  Dir.chdir(daetmp)
  begin
    zipcmd = "zip -rqm "+@modelname+".dae.zip *"
    system(zipcmd)
  rescue
    puts 'zip failed'
  end
  sleep(0.5)
  return if not File.exist?(daepath+'.zip')
  @zipped=true
end

def xpt_obj()
  objtmp = File.join(@outdir, "objtmp")
  Dir.mkdir(objtmp) if not File.exist?(objtmp)
  objpath = File.join(objtmp, @modelname+".obj")
  @model.export(objpath, true)
  Dir.chdir(objtmp)
  begin
    zipcmd = "zip -rqm "+@modelname+".obj.zip *"
    system(zipcmd)
  rescue
    puts 'zip failed'
  end
  sleep(0.5)
  return if not File.exist?(objpath+'.zip')
  @zipped=true
end

def xpt_skp_cms()
  Dir.chdir(@outdir)
  cmspath = @modelname + ".skp"
  status = @model.save(cmspath)
end  

##core code
def initialize()

  # set up initial variables
  @model = Sketchup.active_model
  @moempty_dir = @model.path.chomp(@model.title + ".skp")
  @modelname = @model.title.gsub(/[^a-zA-Z0-9_]*/, "")
  @outdir = File.join(@moempty_dir, @modelname+"_out")
  @plugindir = File.dirname(__FILE__)
  conffile = File.join(@plugindir, "/ffexport.conf")
  
  @zipped=false ### needed if zipping fails

  # get the formats to export
  formats = ["dwg","3ds","dae","obj","fbx","jpg"]
  defaultvals = ["false","false","false","false","false","true"]
  possanswers = ["true|false","true|false","true|false","true|false","true|false","true|false|IM|IM DC"]
  
  if File.exist?(conffile)
    vals_stor=IO.readlines(conffile)
    vals_stor.each_with_index{|e,i|vals_stor[i]=e.chomp!}### strip \n
    if defaultvals.length==vals_stor.length
      vals=vals_stor
    else
      vals=defaultvals
    end
  else
    vals=defaultvals
  end

  results=UI.inputbox(formats, vals, possanswers, "Which Formats to Export?")

  #start the real work
  if results

    # change to cms to standardise units
    ### you CAN'T rely on them being in same order between versions!
    @model.options['UnitsOptions']['LengthUnit']=3
    ###

    Dir.mkdir @outdir if not File.exist?(@outdir)

    self.xpt_dwg() if results[0]=="true"
    
    self.xpt_3ds() if results[1]=="true"
    
    self.xpt_dae() if results[2]=="true"

    self.xpt_obj() if results[3]=="true"

    self.xpt_fbx() if results[4]=="true"

    self.xpt_jpg(results[5]) if results[5]!="false" ### fixed!!!

    self.xpt_skp_cms()


    #write out which formats were last used
    f=File.open(conffile,"w")
    f.puts(results)
    f.close

    #cleanup here, in case something is stupid and locks the dirs & zipped
    tdstmp = File.join(@outdir, "3dstmp")
    daetmp = File.join(@outdir, "daetmp")
    objtmp = File.join(@outdir, "objtmp")
    fbxtmp = File.join(@outdir, "fbxtmp")
    
    [tdstmp,daetmp,objtmp,fbxtmp].each{|d|
      if File.exist?(d)
        if File.ftype(d)=='directory'
          self.copy_zip(d,@outdir)
          self.empty_dir(d)
          Dir.delete(d)
        else
          File.delete(d)
        end#if
      end#if
    } if @zipped ### trapped if zipping fails ???
    
    arep=File.join(@outdir,"Audit report.txt")
    File.delete(arep)if File.exist?(arep)### optional removal ???
    
    Dir.chdir(@plugindir)
    puts @outdir
    puts Dir.entries(@outdir)
    puts
    puts 'FFexport Done.'
    
    ### optional dir open
    UI.openURL('file:/'+@outdir)
    
  end#if
  
end#initialize

def empty_dir(dir)
  Dir.entries(dir).each{|f|
    next if f=='.' or f=='..'
    if File.ftype(File.join(dir,f))=='directory'
      self.empty_dir(File.join(dir,f))
      Dir.delete(File.join(dir,f))
    else
      File.delete(File.join(dir,f))
    end
  }
end

def copy_zip(fol, dir)
  zip=nil
  Dir.entries(fol).each{|f|
    if File.extname(f).downcase=='.zip'
      zip=File.join(fol,f)
      break
    end
  }
  return nil if not zip
  zfile=File.join(dir, File.basename(zip))
  ### get data
  file=File.open(zip,"r")
    file.binmode
    data=file.read
  file.close
  ### copy file
  file=File.open(zfile,"w")
    file.binmode
    file.write(data)
  file.close
end

end#class

#######################

if not $ffexport_menu_loaded
  add_separator_to_menu("Plugins")
  UI.menu("Plugins").add_item("FF Exporter"){AF_FF.new()}
end
$ffexport_menu_loaded = true
